/**************************************************************************
***************************************************************************
			PROBLEME DE LAMBERT
		PROGRAMME CONTENANT LES FONCTIONS D'AFFICHAGE
***************************************************************************
**************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>

#define pi 3.141592654



//DECLARATION DES FONCTIONS UTILES A CE FICHIER:


//fonctions concernant le cas elliptique:
extern double solution_equation_elliptique_0_tour ();
extern double Solution_du_probleme(double);
extern double classification_des_cas();
extern double premiere_solution_NTour();
extern double deuxieme_solution_NTour();

extern void traitement_cas_vol(int );
extern void dernier_parametre ();


//fonction servant  la saisie des donnes de l'utilisateur:
extern void saisir();


//fonction cre dasn ce fichier:
void repeter();


//DECLARATION DES VARIABLES UTILES A CE FICHIER:


//variables concernant le cas elliptique:
extern double a;
extern double excentricite;
extern double ra, rp;
extern double argument;
extern double inclinaison;
extern double longitude;
extern double M;
extern double vitesse1[];
extern double vitesse2[];
extern double V[];
extern double phi1,phi2;
extern double teta1,teta2;
extern double Nvitesse1,Nvitesse2;
extern double gamma1,gamma2;
extern double Vinfini1,Vinfini2;

extern int cas_de_vol;
extern int saisie;


//variables concernant la trajectoire:
extern double DureeMini;
extern double RayonVecteurDepart[4],RayonVecteurArrivee[4];
extern double W12[4], W[4], AxeI[4], AxeJ[4], AxeK[4];
extern double R1, R2, S, D, Angle, Delta, Delta_T, Mu, Lambda, choix;

extern int NTour, Helios, SensParcours,RetourDebut,Choix_Vol_Long_Court;
extern int reponse, planete1,planete2;
extern int compteur;

extern char nom_mission[20];
extern char nom,nom1, azerty, encore;


//variables concernant le cas hyperbolique:
extern double inclinaisonh;
extern double excentriciteh;
extern double ah;
extern double phi1h,phi2h;
extern double teta1h,teta2h;
extern double alphah;
extern double longitudeh;
extern double argumenth;
extern double Sol_O_Tourh;
extern double vitesse1h[4],vitesse2h[4];
extern double AxeWh[4];
extern double Nvitesse1h,Nvitesse2h;

extern int cas_de_volh;



/************************************************************************
			AFFICHAGE ELLIPTIQUE
************************************************************************/


void afficher_elliptique ()
{
	clrscr();
	char rep;


	//SAUVEGARDE DES DONNEES DANS UN FICHIER


	//demande du nom du fichier

	printf("Voulez-vous sauvegarder les rsultats dans un fichier (o/n):");
	scanf("%c",&rep);
	if ((rep=='O')||(rep=='o'))
	{
	char nomfichier[21];
	FILE * sortie;
	printf("\nVous allez saisir le nom du fichier de sauvegarde.\n");
	printf("\n\n                      ATTENTION:\n\n");
	printf("Pour viter tout problme, il est prfrable de placer ce dossier \n la racine de votre disque.\n");
	printf("\nLe nom du fichier doit contenir 8 caractres au maximum sans compter \nle nom de votre disque (c: ou d:) ni .txt.\n");
	printf("\n\nExemple de nom de fichier acceptable: c:/test.txt ou d:/essai1.txt\n");
	printf("\n\nEntrer le nom du fichier: ");


	scanf("%20s",&nomfichier);
	sortie=fopen(nomfichier,"w");

//Sauvegarde dans le fichier

fprintf(sortie,"*******************************************************************************\n");
fprintf(sortie,"**                      PROJET: RESOLUTION DU PROBLEME DE LAMBERT            **\n");
fprintf(sortie,"**                         EMILIE CASTELLANI ET ISABELLE DAUVIN              **\n");
fprintf(sortie,"**                            PROMOTION 2002/2003 DU DESS TAE                **\n");
fprintf(sortie,"*******************************************************************************\n");

fprintf(sortie," \n\n\n                                 RAPPEL DE LA MISSION:\n\n");


	if ((azerty=='o')||(azerty=='O'))
	{
	fprintf(sortie, "Le nom de la mission est:\n");
	for (int y=0;y<=19;y++)fprintf(sortie,"%c",nom_mission[y]);
	}

	fprintf(sortie,"\n");

	fprintf(sortie,"Le vol est elliptique.\n\n");

	if (Helios==1)
	fprintf(sortie,"Vous avez choisi un vol heliocentrique en %d tour(s).\n\n",NTour);
	if (Helios==0)
	fprintf(sortie,"Vous avez choisi un vol geocentrique en %d tour(s).\n\n",NTour);

	fprintf(sortie,"\n\n");
	fprintf(sortie,"La mission part du point:\n\n");
	fprintf(sortie,"X=%.1lf km\n",RayonVecteurDepart[1]);
	fprintf(sortie,"Y=%.1lf km\n",RayonVecteurDepart[2]);
	fprintf(sortie,"Y=%.1lf km\n\n",RayonVecteurDepart[3]);
	fprintf(sortie,"pour arriver au point:\n\n");
	fprintf(sortie,"X=%.1lf km\n",RayonVecteurArrivee[1]);
	fprintf(sortie,"Y=%.1lf km\n",RayonVecteurArrivee[2]);
	fprintf(sortie,"Y=%.1lf km\n",RayonVecteurArrivee[3]);


fprintf(sortie," \n                PARAMETRES ORBITAUX DE LA CONIQUE SOLUTION:\n\n");


	fprintf(sortie,"Demi grand axe: %20.1lf km\n\n",a);
	fprintf(sortie,"Excentricite: %21lf\n\n",excentricite);
	fprintf(sortie,"Inclinaison orbitale: %14.3lf deg\n\n",inclinaison);
	fprintf(sortie,"Rayon a l'apogee: %18.1lf km\n\n",ra);
	fprintf(sortie,"Rayon au perigee: %18.1lf km\n\n",rp);
	fprintf(sortie,"Longitude vernale: %17.lf deg\n\n", longitude*180/pi);
	fprintf(sortie,"Argument nodal au perigee: %8.1lf deg\n\n",argument*180/pi);
	fprintf(sortie,"Anomalie moyenne: %18.3lf deg\n\n",M);
	fprintf(sortie,"Duree du voyage: %19lf jours decimaux\n\n",Delta_T);
	fprintf(sortie,"Duree minimale du voyage: %9lf jours decimaux\n\n",DureeMini);
	fprintf(sortie,"Anomalie excentrique en P1: %7.3lf\n\n",phi1*180/pi);
	fprintf(sortie,"Anomalie excentrique en P2: %7.3lf\n\n",phi2*180/pi);
	fprintf(sortie,"Anomalie vraie au depart: %9.3lf deg\n\n",teta1);
	fprintf(sortie,"Anomalie vraie a l'arrivee: %7.3lf deg\n\n",teta2);
	fprintf(sortie,"Pente au depart: %19.3lf deg\n\n",gamma1);
	fprintf(sortie,"Pente a l'arrivee: %17.3lf deg\n\n",gamma2);

	fprintf(sortie,"\n\n");


fprintf(sortie,"indice 1: point de depart, indice 2: point d'arrivee\n\n");
fprintf(sortie,"Distance entre le foyer principal de l'orbite et P1: %.1lf km\n",R1);
fprintf(sortie,"Distance entre le foyer principal de l'orbite et P2: %.1lf km\n",R2);
	fprintf(sortie,"\n");


	switch (cas_de_vol)
	{
case 1:fprintf(sortie,"Cas de vol 1: ellipse, R1<R2, P1 et P2 montants, delta<90 deg\n");
break;
case 2:fprintf(sortie,"Cas de vol 2: ellipse, R1<R2, P1 montant et P2 descendant, delta<90 deg\n");
break;
case 3:fprintf(sortie,"Cas de vol 3: ellipse, R1<R2, P1 montant et P2 descendant, delta>90 deg\n");
break;
case 4:fprintf(sortie,"Cas de vol 4: ellipse, R1<R2, P1 et P2 descendants, delta>90 deg\n");
break;
case 5:fprintf(sortie,"Cas de vol 5: ellipse, R1<R2, P1 descendant et P2 montant, delta>90 deg\n");
break;
case 6:fprintf(sortie,"Cas de vol 6: ellipse, R1>R2, P1 montant et P2 descendant, delta<90 deg\n");
break;
case 7:fprintf(sortie,"Cas de vol 7: ellipse, R1>R2, P1 et P2 descendants, delta<90 deg\n");
break;
case 8:fprintf(sortie,"Cas de vol 8: ellipse, R1>R2, P1 et P2 montants, delta>90 deg\n");
break;
case 9:fprintf(sortie,"Cas de vol 9: ellipse, R1>R2, P1 descendant et P2 montant, delta>90 deg\n");
break;
case 10:fprintf(sortie,"Cas de vol 10: ellipse, R1>R2, P1 descendant et P2 montant, delta<90 deg\n");
break;
	}
	fprintf(sortie,"\n");


	switch (Choix_Vol_Long_Court)
	{
	case 1:fprintf(sortie,"Vous aviez choisi un voyage court.\n");
	break;
	case 2:fprintf(sortie,"Vous aviez choisi un voyage long.\n");
	break;
	case 3:fprintf(sortie,"Vous aviez choisi un voyage long.\n");
	break;
	case 4:fprintf(sortie,"Vous aviez choisi un voyage court.\n");
	break;
	}


	fprintf(sortie,"\n");

	fprintf(sortie,"Vitesse de depart (en km/s):\n\n");
	for (int l=1;l<=3;l++)
	fprintf(sortie,"v%d: %.4lf\n", l, vitesse1[l]);
	fprintf(sortie,"Norme de la vitesse  de depart:%.4lf km/s\n",Nvitesse1);
	fprintf(sortie,"\n");
	if (planete1==1)
	{
	fprintf(sortie,"vitesse infini a l'arrivee: %.4lf km/s\n",Vinfini2);
	}
	fprintf(sortie,"Vitesse d'arrivee (en km/s):\n\n");
	for (int j=1;j<=3;j++)
	fprintf(sortie,"v%d: %.4lf\n", j, vitesse2[j]);
	fprintf(sortie,"Norme de la vitesse d'arrivee: %.4lf km/s\n",Nvitesse2);
	if (planete2==1)
	{
	 fprintf(sortie,"Vitesse infini a l'arrivee: %.4lf km/s\n",Vinfini2);
	}
	fprintf(sortie,"\n");
	fclose(sortie);
	}



	getchar();
	clrscr();


	// AFFICHAGE A L'ECRAN

printf("\n\n\n\n");


printf("*******************************************************************************\n");
printf("**                                                                           **\n");
printf("**                                                                           **\n");
printf("**                      PROJET: RESOLUTION DU PROBLEME DE LAMBERT            **\n");
printf("**                                                                           **\n");
printf("**                         EMILIE CASTELLANI ET ISABELLE DAUVIN              **\n");
printf("**                                                                           **\n");
printf("**                            PROMOTION 2002/2003 DU DESS TAE                **\n");
printf("**                                                                           **\n");
printf("**                                                                           **\n");
printf("*******************************************************************************\n");

printf("\n\nAppuyez sur une touche.");
getchar();
clrscr();



printf(" \n                               RAPPEL DE LA MISSION:\n");
	printf("\n");


	if ((azerty=='o')||(azerty=='O'))
	{
	printf( "Le nom de la mission est:\n");
	for (int y=0;y<=19;y++)printf("%c",nom_mission[y]);
	}

	printf("\n");



	if (Helios==1)
	printf("Vous avez choisi un vol hliocentrique en %d tour(s).\n",NTour);
	if (Helios==0)
	printf("Vous avez choisi un vol gocentrique en %d tour(s).\n",NTour);

	printf("\n\n");
	printf("La mission part du point:\n\n");
	printf("X=%.1lf km\n",RayonVecteurDepart[1]);
	printf("Y=%.1lf km\n",RayonVecteurDepart[2]);
	printf("Y=%.1lf km\n\n",RayonVecteurDepart[3]);
	printf("pour arriver au point:\n\n");
	printf("X=%.1lf km\n",RayonVecteurArrivee[1]);
	printf("Y=%.1lf km\n",RayonVecteurArrivee[2]);
	printf("Y=%.1lf km\n",RayonVecteurArrivee[3]);

	printf("\n\n************* ATTENTION, NOTEZ LES RESULTATS QUI VONT ETRE EFFACES *************\n");

	getchar();

	clrscr();




	printf(" \n                PARAMETRES ORBITAUX DE LA CONIQUE SOLUTION:\n");
	printf("\n\n");

	printf("Demi grand axe: %20.1lf km\n\n",a);
	printf("Excentricit: %22lf\n\n",excentricite);
	printf("Inclinaison orbitale: %14.3lf\n\n",inclinaison);
	printf("Rayon  l'apoge: %18.1lf km\n\n",ra);
	printf("Rayon au prige: %18.1lf km\n\n",rp);
	printf("Longitude vernale: %17.3lf\n\n", longitude*180/pi);
	printf("Argument nodal au prige: %9.3lf\n\n",argument*180/pi);
	printf("Anomalie moyenne: %18.3lf\n\n",M);

	printf("\n\n************* ATTENTION, NOTEZ LES RESULTATS QUI VONT ETRE EFFACES *************\n");

	getchar();

	clrscr();
	printf(" \n                PARAMETRES ORBITAUX DE LA CONIQUE SOLUTION:\n");
	printf("\n\n");

	printf("Dure du voyage: %20lf jours dcimaux\n",Delta_T);
	printf("Dure minimale du voyage: %11lf jours dcimaux\n\n",DureeMini);
	printf("Anomalie excentrique en P1: %7.3lf\n",phi1*180/pi);
	printf("Anomalie excentrique en P2: %7.3lf\n\n",phi2*180/pi);
	printf("Anomalie vraie en P1: %13.3lf\n",teta1);
	printf("Anomalie vraie en P2: %13.3lf\n\n",teta2);
	printf("Pente de la vitesse en P1: %8.3lf\n",gamma1);
	printf("Pente de la vitesse en P2: %8.3lf\n\n",gamma2);







printf("************* ATTENTION, NOTEZ LES RESULTATS QUI VONT ETRE EFFACES *************\n");

	getchar();

	clrscr();



	printf(" \n                PARAMETRES ORBITAUX DE LA CONIQUE SOLUTION:\n");
	printf("\n");

	printf("indice 1: point de dpart, indice 2: point d'arrive\n\n");
printf("Distance entre le foyer principal de l'orbite et P1: %.1lf km\n",R1);
printf("Distance entre le foyer principal de l'orbite et P2: %.1lf km\n",R2);
	printf("\n");


	switch (cas_de_vol)
	{
case 1:printf("Cas de vol n1: ellipse, R1<R2, P1 et P2 montants, delta<90\n");
break;
case 2:printf("Cas de vol n2: ellipse, R1<R2, P1 montant et P2 descendant, delta<90\n");
break;
case 3:printf("Cas de vol n3: ellipse, R1<R2, P1 montant et P2 descendant, delta>90\n");
break;
case 4:printf("Cas de vol n4: ellipse, R1<R2, P1 et P2 descendants, delta>90\n");
break;
case 5:printf("Cas de vol n5: ellipse, R1<R2, P1 descendant et P2 montant, delta>90\n");
break;
case 6:printf("Cas de vol n6: ellipse, R1>R2, P1 montant et P2 descendant, delta<90\n");
break;
case 7:printf("Cas de vol n7: ellipse, R1>R2, P1 et P2 descendants, delta<90\n");
break;
case 8:printf("Cas de vol n8: ellipse, R1>R2, P1 et P2 montants, delta>90\n");
break;
case 9:printf("Cas de vol n9: ellipse, R1>R2, P1 descendant et P2 montant, delta>90\n");
break;
case 10:printf("Cas de vol n10: ellipse, R1>R2, P1 descendant et P2 montant, delta<90\n");
break;
	}



	switch (Choix_Vol_Long_Court)
	{
	case 1:printf("Vous aviez choisi un voyage court.\n");
	break;
	case 2:printf("Vous aviez choisi un voyage long.\n");
	break;
	case 3:printf("Vous aviez choisi un voyage long.\n");
	break;
	case 4:printf("Vous aviez choisi un voyage court.\n");
	break;
	}


	printf("\n");

	printf("Vitesse de dpart (en km/s):\n");
	for (int i=1;i<=3;i++)
	printf("v%d: %.4lf\n", i, vitesse1[i]);
	printf("Norme de la vitesse  de dpart:%.4lf km/s\n",Nvitesse1);
	if(planete1==1)
	{
	printf("Vitesse infini au depart: %.4lf km/s\n",Vinfini1);
	}
	printf("\n");
	printf("Vitesse d'arrive (en km/s):\n");
	for (int j=1;j<=3;j++)
	printf("v%d: %.4lf\n", j, vitesse2[j]);
	printf("Norme de la vitesse d'arrive: %.4lf km/s\n",Nvitesse2);
	if(planete2==1)
	{
	printf("Vitesse infini a l'arrivee: %.4lf km/s\n",Vinfini2);
	}


	printf("************* ATTENTION, NOTEZ LES RESULTATS ");
	printf("QUI VONT ETRE EFFACES *************");

	getchar();

}

/************************************************************************
			AFFICHAGE HYPERBOLIQUE
************************************************************************/

void afficher_hyperbolique()
{
	clrscr();
	char rep;



	//SAUVEGARDE DES DONNEES DANS UN FICHIER

	//demande du nom du fichier

	printf("Voulez-vous sauvegarder les rsultats dans un fichier (o/n):");
	scanf("%c",&rep);
	if ((rep=='O')||(rep=='o'))
	{
	char nomfichier[21];
	FILE * sortie;
	printf("\nVous allez saisir le nom du fichier de sauvegarde.\n");
	printf("\n\n                      ATTENTION:\n\n");
	printf("Pour viter tout problme, il vaut mieux placer ce dossier \n la racine de votre disque.\n");
	printf("\nLe nom du fichier doit contenir 8 caractres au maximum \nsans compter le nom de votre disque (c: ou d:) ni .txt.\n");
	printf("\n\nExemple de nom de fichier acceptable: c:/test.txt ou d:/essai1.txt\n");
	printf("\n\nEntrer le nom du fichier: ");


	scanf("%20s",&nomfichier);
	sortie=fopen(nomfichier,"w");

//criture dans le fichier de sauvegarde

fprintf(sortie,"*******************************************************************************\n");
fprintf(sortie,"**                      PROJET: RESOLUTION DU PROBLEME DE LAMBERT            **\n");
fprintf(sortie,"**                         EMILIE CASTELLANI ET ISABELLE DAUVIN              **\n");
fprintf(sortie,"**                            PROMOTION 2002/2003 DU DESS TAE                **\n");
fprintf(sortie,"*******************************************************************************\n");

fprintf(sortie," \n\n\n                                 RAPPEL DE LA MISSION:\n");
	fprintf(sortie,"\n\n");


	if ((azerty=='o')||(azerty=='O'))
	{
	fprintf(sortie, "Le nom de la mission est:\n");
	for (int y=0;y<=19;y++)fprintf(sortie,"%c",nom_mission[y]);
	}

	fprintf(sortie,"\nLe vol est hyperbolique.\n\n");

	if (Helios==1)
	fprintf(sortie,"Vous avez choisi un vol heliocentrique en %d tour(s).\n\n",NTour);
	if (Helios==0)
	fprintf(sortie,"Vous avez choisi un vol geocentrique en %d tour(s).\n\n",NTour);

	fprintf(sortie,"\n\n");
	fprintf(sortie,"La mission part du point:\n\n");
	fprintf(sortie,"X=%.1lf km\n",RayonVecteurDepart[1]);
	fprintf(sortie,"Y=%.1lf km\n",RayonVecteurDepart[2]);
	fprintf(sortie,"Y=%.1lf km\n\n",RayonVecteurDepart[3]);
	fprintf(sortie,"pour arriver au point:\n\n");
	fprintf(sortie,"X=%.1lf km\n",RayonVecteurArrivee[1]);
	fprintf(sortie,"Y=%.1lf km\n",RayonVecteurArrivee[2]);
	fprintf(sortie,"Y=%.1lf km\n",RayonVecteurArrivee[3]);





fprintf(sortie," \n                PARAMETRES ORBITAUX DE LA CONIQUE SOLUTION:\n\n");


	fprintf(sortie,"Demi grand axe: %24.1lf km\n\n",ah);
	fprintf(sortie,"Excentricite: %31lf\n\n",excentriciteh);
	fprintf(sortie,"Inclinaison orbitale: %20.3lf deg\n\n",inclinaisonh*180/pi);
	fprintf(sortie,"Rayon au perigee: %22.1lf km\n\n",fabs(ah*(1-excentriciteh)));
	fprintf(sortie,"Longitude vernale: %23.3lf deg\n\n", longitudeh*180/pi);
	fprintf(sortie,"Argument nodal au perigee: %15.3lf deg\n\n",argumenth*180/pi);
	fprintf(sortie,"Duree du voyage: %28lf jours decimaux\n\n",Delta_T);
	fprintf(sortie,"Duree minimale du voyage: %19lf jours decimaux\n\n",DureeMini);
	fprintf(sortie,"Anomalie excentrique au depart: %10.3lf\n\n",fabs(phi1h*180/pi));
	fprintf(sortie,"Anomalie excentrique a l'arrivee: %8.3lf\n\n",fabs(phi2h*180/pi));
	fprintf(sortie,"Anomalie vraie au depart: %16.3lf deg\n\n",teta1h*180/pi);
	fprintf(sortie,"Anomalie vraie a l'arrivee: %14.3lf deg\n\n",teta2h*180/pi);

	fprintf(sortie,"\n\n");
	fprintf(sortie,"indice 1: point de depart, indice 2: point d'arrivee\n\n");
	fprintf(sortie,"Distance entre le foyer de l'orbite et P1: %.1lf km\n",R1);
	fprintf(sortie,"Distance entre le foyer de l'orbite et P2: %.1lf km\n",R2);
	fprintf(sortie,"\n");


	switch (cas_de_volh)
	{
	case 11:fprintf(sortie,"Cas de vol 11: hyperbole, R1<R2, P1 descendant et P2 infini, delta<90 deg\n");
	break;
	case 12:fprintf(sortie,"Cas de vol 12: hyperbole, R1<R2, P1 montant et P2 infini, delta<90 deg\n");
	break;
	case 13:fprintf(sortie,"Cas de vol 13: hyperbole, R1<R2, P1 descendant et P2 infini, delta>90 deg\n");
	break;
	case 14:fprintf(sortie,"Cas de vol 14: hyperbole, R1>R2, P1 infini et P2 descendant, delta<90 deg\n");
	break;
	case 15:fprintf(sortie,"Cas de vol 15: hyperbole, R1>R2, P1 infini et P2 montant, delta<90 deg\n");
	break;
	case 16:fprintf(sortie,"Cas de vol 16: hyperbole, R1>R2, P1 infini et P2 montant, delta>90 deg\n");
	break;
	}
	fprintf(sortie,"\n");


	fprintf(sortie,"\n");

	fprintf(sortie,"Vitesse de depart (en km/s):\n\n");
	for (int l=1;l<=3;l++)
	fprintf(sortie,"v%d: %.4lf\n", l, vitesse1h[l]);
	fprintf(sortie,"Norme de la vitesse  de depart:%.4lf km/s\n",Nvitesse1h);
	fprintf(sortie,"\n");
	fprintf(sortie,"Vitesse d'arrivee (en km/s):\n\n");
	for (int j=1;j<=3;j++)
	fprintf(sortie,"v%d: %.4lf\n", j, vitesse2h[j]);
	fprintf(sortie,"Norme de la vitesse d'arrivee: %.4lf km/s\n",Nvitesse2h);

	fprintf(sortie,"\n");
	fclose(sortie);
	}



	getchar();
	clrscr();


	// AFFICHAGE A L'ECRAN

	printf("\n\n\n\n\n");



	printf("*******************************************************************************\n");
	printf("**                                                                           **\n");
	printf("**                      PROJET: RESOLUTION DU PROBLEME DE LAMBERT            **\n");
	printf("**                         EMILIE CASTELLANI ET ISABELLE DAUVIN              **\n");
	printf("**                            PROMOTION 2002/2003 DU DESS TAE                **\n");
	printf("**                                                                           **\n");
	printf("*******************************************************************************\n");

	printf("\n\nAppuyez sur une touche.");
	getchar();
	clrscr();




	printf(" \n\n\n                                 RAPPEL DE LA MISSION:\n");
	printf("\n\n");


	if ((azerty=='o')||(azerty=='O'))
	{
	printf("Le nom de la mission est:\n");
	for (int y=0;y<=19;y++)printf("%c",nom_mission[y]);
	}

	printf("\n");


	if (Helios==1)
	printf("Vous avez choisi un vol heliocentrique en %d tour(s).\n\n",NTour);
	if (Helios==0)
	printf("Vous avez choisi un vol geocentrique en %d tour(s).\n\n",NTour);

	printf("\n\n");
	printf("La mission part du point:\n\n");
	printf("X=%.1lf km\n",RayonVecteurDepart[1]);
	printf("Y=%.1lf km\n",RayonVecteurDepart[2]);
	printf("Y=%.1lf km\n\n",RayonVecteurDepart[3]);
	printf("pour arriver au point:\n\n");
	printf("X=%.1lf km\n",RayonVecteurArrivee[1]);
	printf("Y=%.1lf km\n",RayonVecteurArrivee[2]);
	printf("Y=%.1lf km\n",RayonVecteurArrivee[3]);

	printf("\n\nAppuyez sur une touche.");
	getchar();
	clrscr();





	printf(" \n                PARAMETRES ORBITAUX DE LA CONIQUE SOLUTION:\n");
	printf("\n\n");

	if (Helios==1)
	printf("Vous avez choisi un vol hliocentrique.\n\n");
	if (Helios==0)
	printf("Vous avez choisi un vol gocentrique.\n\n");



	printf("Demi grand axe: %24.1lf km\n",ah);
	printf("Excentricit: %31lf\n",excentriciteh);
	printf("Inclinaison orbitale: %20.3lf\n",inclinaisonh*180/pi);
	printf("Rayon au prige: %22.1lf km\n",fabs(ah*(1-excentriciteh)));
	printf("Longitude vernale: %23.3lf\n", longitudeh*180/pi);
	printf("Argument nodal au prige: %15.3lf\n",argumenth*180/pi);
	printf("Dure du voyage: %28lf jours dcimaux\n",Delta_T);
	printf("Dure minimale du voyage: %19lf jours dcimaux\n",DureeMini);
	printf("Anomalie excentrique au dpart: %10.3lf\n",fabs(phi1h*180/pi));
	printf("Anomalie excentrique  l'arrive: %8.3lf\n",fabs(phi2h*180/pi));
	printf("Anomalie vraie au dpart: %16.3lf\n",teta1h*180/pi);
	printf("Anomalie vraie  l'arrive: %14.3lf\n",teta2h*180/pi);

	printf("\n\n************* ATTENTION, NOTEZ LES RESULTATS QUI VONT ETRE EFFACES *************\n");

	getchar();

	clrscr();





	printf("\n\n");
	printf("indice 1: point de dpart, indice 2: point d'arrive\n\n");
	printf("Distance entre le foyer de l'orbite et P1: %.1lf km\n",R1);
	printf("Distance entre le foyer de l'orbite et P2: %.1lf km\n",R2);
	printf("\n");


	switch (cas_de_volh)
	{
	case 11:printf("Cas de vol n11: hyperbole, R1<R2, P1 descendant et P2 infini, delta<90\n");
	break;
	case 12:printf("Cas de vol n12: hyperbole, R1<R2, P1 montant et P2 infini, delta<90\n");
	break;
	case 13:printf("Cas de vol n13: hyperbole, R1<R2, P1 descendant et P2 infini, delta>90\n");
	break;
	case 14:printf("Cas de vol n14: hyperbole, R1>R2, P1 infini et P2 descendant, delta<90\n");
	break;
	case 15:printf("Cas de vol n15: hyperbole, R1>R2, P1 infini et P2 montant, delta<90\n");
	break;
	case 16:printf("Cas de vol n16: hyperbole, R1>R2, P1 infini et P2 montant, delta>90\n");
	break;
	}



	printf("\n");

	printf("Vitesse de dpart:\n");
	for (int i=1;i<=3;i++)
	printf("v%d: %.1lf\n", i, vitesse1h[i]);
	printf("Norme de la vitesse  de dpart:%.1lf km/s\n",Nvitesse1h);
	printf("\n");
	printf("Vitesse de d'arrive:\n");
	for (int j=1;j<=3;j++)
	printf("v%d: %.1lf\n", j, vitesse2h[j]);
	printf("Norme de la vitesse d'arrive: %.1lf km/s\n",Nvitesse2h);



	printf("\n************* ATTENTION, NOTEZ LES RESULTATS QUI VONT ETRE EFFACES *************\n");
	getchar();

	repeter();



}


/**************************************************************************
			FONCTION QUI SERT A RELANCER LE PROGRAMME
**************************************************************************/

void repeter()
{
	if (saisie!=1)
	{
	printf("Voulez-vous relancer le programme pour une autre mission? (o/n):");
	scanf("%c",&encore);
	if ((encore=='n')||(encore=='N'))
	{exit(EXIT_SUCCESS);}
	else clrscr();
	}


while ((encore=='o') || (encore=='O'))
{
	saisir();

	if (NTour==0)
	{
	getchar();
	clrscr();

	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n               ");
	printf("  ON EST A ZERO TOUR. IL N'Y A DONC QU'UNE SOLUTION.\n");
	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
	printf("Appuyez sur une touche.\n");
	getchar();



	choix= solution_equation_elliptique_0_tour();
	Solution_du_probleme(choix);
	classification_des_cas();
	traitement_cas_vol(cas_de_vol);
	dernier_parametre ();
	afficher_elliptique();
	}
	else
	{
	getchar();
	clrscr();
	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n");
	printf("ON EST A PLUS D'UN TOUR.");
	printf("IL Y A DONC DEUX SOLUTIONS POSSIBLES.\n");
	printf("\n\n\n\n\n\n\n                       ");
	printf("              VOICI LA PREMIERE SOLUTION.\n\n\n\n\n\n\n\n");

	printf("Appuyez sur une touche.");
	getchar();


	clrscr();
	choix=premiere_solution_NTour();
	Solution_du_probleme(choix);
	classification_des_cas();
	traitement_cas_vol(cas_de_vol);
	dernier_parametre();
	afficher_elliptique();

	clrscr();
	printf("\n\n\n\n\n\n\n\n\n\n\n\n                ");
	printf("     VOICI LA DEUXIEME SOLUTION.\n\n\n\n\n\n\n\n\n");
	printf("Appuyez sur une touche.");
	getchar();




	choix=deuxieme_solution_NTour();
	Solution_du_probleme(choix);
	classification_des_cas();
	traitement_cas_vol(cas_de_vol);
	dernier_parametre();
	afficher_elliptique();

	}

	printf("Voulez-vous relancer le programme pour une autre mission? (o/n):");
	scanf("%c",&encore);
	if ((encore=='n')||(encore=='N'))
	{exit(EXIT_SUCCESS);}
	else clrscr();


}
}