/**************************************************************************
***************************************************************************
			PROBLEME DE LAMBERT
	PROGRAMME CONTENANT LES FONCTIONS TRAITANT LE CAS ELLIPTIQUE
***************************************************************************
**************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <process.h>

#define pi 3.141592654



//DECLARATION DES FONCTIONS EXTERNES UTILES A CE FICHEIR:

extern double TempsEllipse0(double alpha,double lamdba);
extern double TempsEllipseN(double alpha, double lambda, int NTour);
extern double norme(double vect1[]);
extern double prodscal (double vect1[], double vect2[]);
extern double acosh (double);

extern void unitaire (double vect1[], double result[]);
extern void prodvect ( double vect1[], double vect2[], double result[]);
extern void multiplication_scalaire (double lambda, double vect1[], double result[]);
extern void somme(double vect1[], double vect2[], double result[]);
extern void solution_equation_hyperbolique();
extern void parametres_principaux_hyperbole() ;
extern void parametres_hyperbole();
extern void afficher_hyperbolique();
extern void saisir();
extern void afficher_elliptique();
extern void ephemeride();
extern void saisie_coord();
extern void planete_coord();
extern void coord_planete();
extern void repeter();

extern int classification_cas_hyperbolique();



//DECLARATION DES FONCTIONS LOCALES A CE FICHIERS:

double solution_equation_elliptique_0_tour ();
double Solution_du_probleme(double);
double classification_des_cas();
double premiere_solution_NTour();
double deuxieme_solution_NTour();

void traitement_cas_vol(int );
void dernier_parametre ();
void solution_elliptique();



//DECLARATION DES VARIABLES EXTERNES UTILES A CE PROGRAMME:

extern double D;
extern double Lambda;
extern double Delta_T; /* temps desiree par l'utilisateur*/
extern double S;
extern double RayonVecteurDepart[4],RayonVecteurArrivee[4];
extern double Angle;  /* angle entre les vecteurs de dpart et d'arrive */
extern double Delta;
extern double R1;
extern double R2;
extern double AxeK[4],AxeI[4],AxeJ[4]; /* axes du repere */
extern double Mu;
extern double W[4];
extern double choix;

extern int NTour;
extern int Helios;
extern int saisie;

extern char encore;



//DECLARATION DES VARIABLES LOCALES A CE PROGRAMME:

double excentricite;
double inclinaison;
double ra,rp;
double M; /* anomalie moyenne d'une date */
double argument; /* argument nodal au perigee */
double longitude;  /* longitude vernale */
double a; /* le demi grand axe */
double phi1,phi2; /* anomalie excentrique*/
double teta1,teta2;
double deltaT;    /* temps calcule pour aller de P1 a P2  */
double grand_phi;
double grand_psi;
double A[4];
double vitesse1[4],vitesse2[4]; /* vecteur vitesse */
double Nvitesse1,Nvitesse2;  /* norme des vitesses  */
double gamma1,gamma2;
double Vinfini1,Vinfini2;
double AlphaNmin, DureeMini, DureeMiniN;

int e1,e2,e3,e4,e5,e6;
int cas_de_vol;




/****************************************************************************/
/*************************** solution elliptique ****************************/
/****************************************************************************/

void solution_elliptique()
{
	double Xmin, Xmax, AlphaMin, dx, Prod;
	double F[12], X[12];


	// cas elliptique moins d'un tour

	if (NTour==0)
	    {

		DureeMini=(1-Lambda*Lambda*Lambda)*sqrt(2*exp(3*log(S))/Mu)/3/86400;


		if ( (DureeMini<Delta_T) && (NTour==0))
		{printf("\n\nUn voyage elliptique  moins d'un tour est possible!!\n\n");
		 printf("Appuyez sur une touche.");
		 getchar();
		}

		if ( (DureeMini>=Delta_T) && (NTour==0) )
		{
		/* on lance le calcul d'un vol hyperbolique */
		printf("\n\nUn voyage elliptique  moins d'un tour est impossible!!\n");
		printf("Un voyage hyperbolique vous est propos.\n\n");
		printf("Appuyez sur une touche.");
		getchar();
		getchar();
		saisie=0;
		solution_equation_hyperbolique();
		parametres_principaux_hyperbole() ;
		parametres_hyperbole();
		classification_cas_hyperbolique();
		afficher_hyperbolique();
		}
	    }




	// cas elliptique  N tours
	/* Apres etude de la fonction F(alpha) donnant le temps theorique
	   fonction de alpha, on sait qu'il existe une valeur de alpha
	   minimum. Cette valeur sert de reference pour le calcul des
	   deux trajectoires */
	if (NTour>0)
	{
	Xmin=0.1;
	Xmax=2*pi-0.1;

	for (int k=1; k<=20;k++)
		{
		for (int y=0; y<=10; y++)
			{
			dx=(Xmax-Xmin)/10;
			X[y]=Xmin+y*dx;
			F[y]=TempsEllipseN(X[y],Lambda,NTour);
			}

		for (int h=1; h<=9;h++)
			{
			Prod=(F[h-1]-F[h])*(F[h+1]-F[h]);
			if (Prod>=0)
				{
				Xmin=X[h-1];
				Xmax=X[h+1];
				if ( (Xmin-Xmax)<1e-5)
				AlphaNmin= (Xmax+Xmin)/2;
				}
			}
		}



	if (Helios==1)
		{
		DureeMiniN=sqrt(exp(3*log(S))/Mu/8)/86400*
				TempsEllipseN(AlphaNmin, Lambda, NTour);

		if (DureeMiniN>Delta_T)
		{
		printf("\n\nUn voyage elliptique  %d tour(s) est impossible!!\n",NTour);
		getchar();
		repeter();
		}

		if (DureeMiniN<=Delta_T)
		{
		printf("\n\nUn voyage elliptique  %d tour(s) est possible!!\n", NTour);
		printf("\nAppuyez sur une touche.");
		getchar();
		DureeMini=DureeMiniN;
		}

		}

	if (Helios==0)
		{
		DureeMiniN=sqrt(exp(3*log(S))/Mu/8)*TempsEllipseN(AlphaNmin, Lambda,NTour);
		DureeMiniN=DureeMiniN/86400;

		if (DureeMiniN>Delta_T)
		{
		printf("\n\nUn voyage elliptique  %d tour(s) est impossible!!\n",NTour);
		getchar();
		saisie=0;
		repeter();
		}

		if (DureeMiniN<=Delta_T)
		{
		printf("\n\nUn voyage elliptique  %d tour(s) est possible!!\n", NTour);
		printf("\nAppuyez ur une touche.");
		getchar();
		DureeMini=DureeMiniN;
		}
		}
	}
}



/****************************************************************************/
/************************* solution elliptique 0 tour ***********************/
/****************************************************************************/



double solution_equation_elliptique_0_tour ()
{

	/* declaration des variables */
	double sol_a_0_tour;   /* valeur cherchee pour alpha */
	double Temps_Reduit;   /* temps divise par k pour etre uniforme */
			      /* a TempsEllipse  */
	double Xmin,Xmax;     /* borne de l'intervalle */
	double dx;
	int test;
	double produit_test;
	double X[12],F[12];



	/*************************************************************/
	/*************************************************************/
	// si NTour==0

	/* initialisation */
	test = 1;
	Xmin = 0.1;
	Xmax = 2*pi-0.1;



	Temps_Reduit = (Delta_T*86400)/(sqrt(exp(3*log(S))/8/Mu));

	/* A partir de l'intervalle [Xmin,Xmax]arbitraire on fait evoluer les
	bornes afin de trouver l'intervalle contenant alpha */
	/* on fait evoluer la borne inferieure */
	while(test!=0)
	{
		if(TempsEllipse0(Xmin,Lambda)>=Temps_Reduit)
			{
				Xmin = Xmin/2;
			}
		if(TempsEllipse0(Xmin,Lambda)<Temps_Reduit)
			test = 0;
	}

	test = 1;

	/* on fait evoluer la borne superieure*/
	while(test!=0)
	{
		if(TempsEllipse0(Xmax,Lambda)<=Temps_Reduit)
				(Xmax = (2*pi+Xmax)/2);
		if(TempsEllipse0(Xmax,Lambda)>Temps_Reduit)
				test = 0;
	}



	/* On a maintenant l'intervalle contenant alpha
	   On cherche alha tel que la difference entre Temps_Reduit et
	   et le temps theorique soit inferieur a e-7
	   On reduit successivement l'intervalle par comparaison
	   entre les deux temps */

	test = 1;

	while(test!=0)   /* on itere jusqu'a la precision voulue */
	{

	dx = (Xmax-Xmin)/10; /* pas de parcours de l'intervalle*/
			     /* plus la longueur de l'intervalle diminue
				plus le pas est petit */


	for (int i=1;i<=11;i++)
	{
		X[i] = Xmin+(i-1)*dx;    /* on parcourt tout l'intervalle */
		F[i] = TempsEllipse0(X[i],Lambda);
	}

	for (int j=1;j<=10;j++)
	{
	      produit_test = (Temps_Reduit-F[j])*(Temps_Reduit-F[j+1]);

		if (produit_test<0)
		{
			Xmin = X[j];
			Xmax = X[j+1];
		}

	}


	/* On teste la longueur de l'intervalle pour savoir si la precision
	   desiree est atteinte */
	if ((Xmax-Xmin)<1e-7)
	       {
	       sol_a_0_tour = (Xmax+Xmin)/2; /* la valeur de alpha */
	       test = 0;   /* comme la precision est atteinte
			      on sort de la boucle */
	       }
	}
	return sol_a_0_tour;

}

/***************************************************************************/
/********************* NTour>0, premire solution **************************/
/***************************************************************************/

double premiere_solution_NTour()
{

	double SolNTour;
	double Temps_Reduit;   /* temps divise par k pour etre homogene
				  a TempsEllipse  */
	double Xmin,Xmax;
	double dx;
	int test;
	double produit_test;
	double X[12],F[12];



	Temps_Reduit=Delta_T*86400/(sqrt(exp(3*log(S))/Mu/8));

	/* Calcul des bornes de l'intervalle contenant alpha a partir
	   de la valeur de alphaNmin calculee.
	   Pour la premiere solution on cherche alpha a droite de la valeur
	   alphaNmin */

	Xmax=2*pi-0.1;
	Xmin=(AlphaNmin+Xmax)/2;  /* on part a droite */
	test=1;

	/* Optimisation pour trouver la borne inferieure */
	while (test==1)
	{
		if (TempsEllipseN(Xmin, Lambda, NTour)>= Temps_Reduit)
		Xmin=(Xmin+AlphaNmin)/2;
		else test=0;
	}

	test=1;

	/* Optimisation pour determiner la borne superieure */
	while (test==1)
	{
		if (TempsEllipseN(Xmax,Lambda,NTour)<=Temps_Reduit)
		Xmax=(2*pi+Xmax)/2;
		else test=0;
	}


	/* Connaissant l'intervalle, on cherche la valeur de alpha la plus
	   en accord avec la precision voulue.
	   On procede par comparaisons succesives pour restreindre au fur
	   et a mesure l'intervalle */
	test=1;

	while(test==1)
	{
		dx=(Xmax-Xmin)/10;

		for (int p=1;p<12; p++)
		{
			X[p]=Xmin+(p-1)*dx;
			F[p]=TempsEllipseN(X[p],Lambda,NTour);
		}


		for (int t=1; t<=10;t++)
		{
			produit_test=(Temps_Reduit-F[t])*(Temps_Reduit-F[t+1]);
			if (produit_test<=0)
			{
				Xmin=X[t];
				Xmax=X[t+1];
			}
		}

		/* Si on atteint une taille d'intervalle de e-7 on sort de
		   la boucle */
		if ((Xmax-Xmin)<=1e-7)
		{
			SolNTour=(Xmax+Xmin)/2; /* futur valeur de alpha */
			test=0;
		}
	}
	return SolNTour;

}



/****************************************************************************/
/******************** deuxime solution NTours ******************************/
/****************************************************************************/

double deuxieme_solution_NTour()
{

	double Temps_Reduit;   /* temps divise par k pour etre uniforme
				  a TempsEllipse  */
	double SolNTour;
	double Xmin,Xmax;
	double dx;
	int test;
	double produit_test;
	double X[12],F[12];


	/* Dans le calcul de la deuxieme solution, on calcule l'intervalle
	   en lancant le calcul a gauche de alphaNmin */
	Temps_Reduit=Delta_T*86400/(sqrt(exp(3*log(S))/Mu/8));
	Xmin=0.1;
	Xmax=(AlphaNmin+Xmin)/2; /* on restreint par la gauche */
	test=1;

	/* On restreint l'intervalle en fesant varier la borne inferieure */
	while (test==1)
	{
		if (TempsEllipseN(Xmin, Lambda,NTour)<=Temps_Reduit)
		Xmin=Xmin/2;
		else test=0;
	}

	test=1;

	/* On restreint l'intervalle en modifiant la valeur de Xmax */
	while (test==1)
	{
		if (TempsEllipseN(Xmax,Lambda,NTour)>=Temps_Reduit)
		Xmax=(Xmax+AlphaNmin)/2;
		else test=0;
	}


	// rsolution
	/* La determination de alpha se fait par restrictions successives
	   de l'intervalle */
	test=1;
	while (test==1)
	{
		dx=(Xmax-Xmin)/10; /* Definition du pas de parcours */

		for (int a=1; a<=11;a++)
		{
			X[a]=Xmin+(a-1)*dx;
			F[a]=TempsEllipseN(X[a],Lambda,NTour);
		}

		for (int b=1; b<=10;b++)
		{
			produit_test=(Temps_Reduit-F[b])*(Temps_Reduit-F[b+1]);
			if (produit_test<=0)
			{
				Xmax=X[b+1];
				Xmin=X[b];
			}
		}

		/* On teste pour savoir si la resolution a conduit
		   a la precision voulue*/
		if ((Xmax-Xmin)<1e-7)
		{
			SolNTour=(Xmin+Xmax)/2;
			test=0;
		}
	}

	return SolNTour;
}


/****************************************************************************/
/********************** calcul des parametres de l'ellipse ******************/
/****************************************************************************/


double Solution_du_probleme(double alpha)
{
	/* prototype des fonctions */
	double solution_equation_elliptique_0_tour();

	/* declaration des variables locales */
	double beta,phi,psi;


	/* calcul de Beta */
	beta = 2*asin(Lambda*sin(alpha/2));
	phi = (alpha+beta)/2;
	psi = (alpha-beta)/2;


	/* calcul de l'excentricite */
	excentricite = sqrt((cos(phi)*cos(phi))+((R1-R2)*sin(phi)/D)
					*((R1-R2)*sin(phi)/D));


	/* calcul du demi-grand axe */
	a = S/(1-cos(alpha));


	/* calcul de phi1 et de phi2 */

	double phi11,phi12,phi21,phi22;

	/* Afin de bien determiner les angles phi1 et phi2 on prend en compte
	   les differentes orientations possibles.
	   Celles-ci sont indeterminees du fait de l'arccos */
	phi11 = acos((1-R1/a)/excentricite);
	phi12 = 2*pi-phi11;
	phi21 = acos((1-R2/a)/excentricite);
	phi22 = 2*pi-phi21;

	/* On determine l'orientation correcte des deux angles */
	if (fabs(phi21-phi11-2*psi)<1e-3)
	{
		phi1 = phi11;
		phi2 = phi21;
	}

	if (fabs(phi22-phi11-2*psi)<1e-3)
	{
		phi1 = phi11;
		phi2 = phi22;
	}

	if (fabs(phi21-phi12-2*psi)<1e-3)
	{
		phi1 = phi12;
		phi2 = phi21;
	}

	if (fabs(phi22-phi12-2*psi)<1e-3)
	{
		phi1 = phi12;
		phi2 = phi22;
	}

	if (fabs(phi21-phi11-2*psi+2*pi)<1e-3)
	{
		phi1 = phi11;
		phi2 = phi21;
	}

	if (fabs(phi22-phi11-2*psi+2*pi)<1e-3)
	{
		phi1 = phi11;
		phi2 = phi22;
	}

	if (fabs(phi21-phi12-2*psi+2*pi)<1e-3)
	{
		phi1 = phi12;
		phi2 = phi21;
	}

	if (fabs(phi22-phi12-2*psi+2*pi)<1e-3)
	{
		phi1 = phi12;
		phi2 = phi22;
	}

	/* Calcul des rayons au perigee rp et a l'apogee ra */
	ra=a*(1+excentricite);
	rp=a*(1-excentricite);

	return 0;

}




/***************************************************************************/
/****************** classification des differents cas **********************/
/***************************************************************************/



double classification_des_cas()
{
	/* Les differentes positions des points de depart et d'arrivee sur
	   la futur trajectoire implique de multiples configuration de tir.
	   Chaque cas est represente par un sextuplet de valeurs booleennes.
	   Initialisation de ces valeurs  */

	if (R1<R2) (e1 = 1);
	else (e1 = 0);

	if (phi1<phi2) (e2 = 1);
	else (e2 = 0);

	if (phi1<pi) (e3 = 1); /* P1 est soit en montee,soit en descente */
	else(e3 = 0);

	if (phi2<pi) (e4 = 1); /* P2 est soit en montee,soit en descente */
	else (e4 = 0);

	if (Angle<pi) (e5 = 1); /* l'angle entre les vecteurs de depart et
				   d'arrivee est ou pas inferieur a pi */
	else (e5 = 0);


	/* Classification des differents cas */
	if ((e1==1)&&(e2==1)&&(e3==1)&&(e4==1)&&(e5==1))
		(cas_de_vol = 1);

	if ((e1==1)&&(e2==1)&&(e3==1)&&(e4==0)&&(e5==1))
		cas_de_vol = 2;

	if ((e1==1)&&(e2==1)&&(e3==1)&&(e4==0)&&(e5==0))
		cas_de_vol = 3;

	if ((e1==1)&&(e2==0)&&(e3==0)&&(e4==0)&&(e5==0))
		cas_de_vol = 4;

	if ((e1==1)&&(e2==0)&&(e3==0)&&(e4==1)&&(e5==0))
		cas_de_vol = 5;

	if ((e1==0)&&(e2==1)&&(e3==1)&&(e4==0)&&(e5==1))
		cas_de_vol = 6;

	if ((e1==0)&&(e2==1)&&(e3==0)&&(e4==0)&&(e5==1))
		cas_de_vol = 7;

	if ((e1==0)&&(e2==0)&&(e3==1)&&(e4==1)&&(e5==0))
		cas_de_vol = 8;

	if ((e1==0)&&(e2==0)&&(e3==0)&&(e4==1)&&(e5==0))
		cas_de_vol = 9;

	if ((e1==0)&&(e2==0)&&(e3==0)&&(e4==1)&&(e5==1))
		cas_de_vol = 10;


return 0;
}




/****************************************************************************/
/*********************** traitement des cas de vol **************************/
/****************************************************************************/

void traitement_cas_vol(int cas_de_vol)
{
	int type=0;
	double B[4];

	/* On regroupe les differents cas en quatre grands cas */
	switch (cas_de_vol)
	{
		case 1 : type = 0;
		break;
		case 2 : type = 0;
		break;
		case 3 : type = 0;
		break;
		case 4 : type = 1;
		break;
		case 5 : type = 1;
		break;
		case 6 : type = 2;
		break;
		case 7 : type = 2;
		break;
		case 8 : type = 3;
		break;
		case 9 : type = 3;
		break;
		case 10 : type = 3;
		break;
	}


	switch (type)
	{
		case 0 :
		{
		  grand_psi = (phi2-phi1)/2;
		  grand_phi = acos(excentricite*(cos((phi1+phi2)/2)));
		  deltaT = sqrt(a*a*a/Mu)*(phi2-phi1-
			      excentricite*(sin(phi2)-sin(phi1)));
		  /*  calcul de W */
		  prodvect(RayonVecteurDepart,RayonVecteurArrivee,A);
		  unitaire(A,A);
		}
		break;

		case 1 :
		{
		  grand_psi = pi-((phi2-phi1)/2);
		  grand_phi = acos(-excentricite*(cos((phi1+phi2)/2)));
		  deltaT = sqrt(a*a*a/Mu)*(2*pi-phi2-phi1-
			      excentricite*(sin(phi2)-sin(phi1)));

		  /*  calcul de W */
		  prodvect(RayonVecteurDepart,RayonVecteurArrivee,A);
		  unitaire(A,A);
		}
		break;

		case 2 :
		{
		  grand_psi = (phi2-phi1)/2;
		  grand_phi = acos(excentricite*(cos((phi1+phi2)/2)));
		  deltaT = sqrt(a*a*a/Mu)*(phi2-phi1-
			      excentricite*(sin(phi2)-sin(phi1)));

		  /*  calcul de W */
		  prodvect(RayonVecteurDepart,RayonVecteurArrivee,A);
		  unitaire(A,A);
		}
		break;

		case 3 :
		{
		  grand_psi = pi-((phi2-phi1)/2);
		  grand_phi = acos(-excentricite*(cos((phi1+phi2)/2)));
		  deltaT = sqrt(a*a*a/Mu)*(2*pi-phi2-phi1-
			      excentricite*(sin(phi2)-sin(phi1)));
		  /*  calcul de W */
		  prodvect(RayonVecteurDepart,RayonVecteurArrivee,A);
		  unitaire(A,A);
		}
		break;
	}
}



/***************************************************************************/
/****************** ultimes parametres orbitaux ****************************/
/***************************************************************************/


void dernier_parametre ()
{
	double costeta1;
	double costeta2;
	double sinteta1;
	double sinteta2;
	double radial1[4],radial2[4];
	double V11[4],V12[4],V21[4],V22[4];
	double orthoradial1[4],orthoradial2[4];
	double constante,Ci,lg1,lg2,e3,e4,rp,Vp;
	double N[4];  /* vecteur unitaire de la ligne des noeuds */
	double N1[4]; /* variable intermediaire */
	double VectExc[4],e1[4],e2[4],rp1[4],rp2[4]; /* vecteur excentricite */
	double h[4];


	/* calcul de teta1 et teta2 symboles des anomalies vraies */

	costeta1 = (cos(phi1)-excentricite)/(1-excentricite*cos(phi1));
	costeta2 = (cos(phi2)-excentricite)/(1-excentricite*cos(phi2));
	sinteta1 = (sqrt(1-excentricite*excentricite)*sin(phi1))
			/(1-excentricite*cos(phi1));
	sinteta2 = (sqrt(1-excentricite*excentricite)*sin(phi2))
			/(1-excentricite*cos(phi2));

	teta1 = acos(costeta1)*180/pi;
	teta2 = acos(costeta2)*180/pi;


	/* calcul des vecteurs vitesse */
	double AxeW[4];
	unitaire(W,AxeW); /* On norme le vecteur W */
	unitaire(RayonVecteurDepart,radial1); /* On definit le vecteur radial*/
	unitaire(RayonVecteurArrivee,radial2);
	prodvect(AxeW,radial1,orthoradial1); /* Definition du vecteur  */
	prodvect(AxeW,radial2,orthoradial2);    /* orthoradial */
	constante = sqrt(Mu/(a*(1-(excentricite*excentricite))));
	multiplication_scalaire (constante*excentricite*sinteta1,radial1,V11);
	multiplication_scalaire (constante*excentricite*sinteta2,radial2,V21);
	multiplication_scalaire (constante*(1+excentricite*costeta1),orthoradial1,V12);
	multiplication_scalaire (constante*(1+excentricite*costeta2),orthoradial2,V22);

	somme(V11,V12,vitesse1);
	somme(V21,V22,vitesse2);

	Nvitesse1 = norme(vitesse1);
	Nvitesse2 = norme(vitesse2);

	/* calcul de la pente de la vitesse */
	double cosgamma1,cosgamma2;
	cosgamma1=sqrt((1-excentricite*excentricite)/
		(1-excentricite*excentricite*cos(phi1)*cos(phi1)));
	cosgamma2=sqrt((1-excentricite*excentricite)/
		(1-excentricite*excentricite*cos(phi2)*cos(phi2)));

	gamma1 = acos(cosgamma1); /* pente de la vitesse V1 */
	gamma2 = acos(cosgamma2); /* pente de la vitesse V2 */



	/* calcul de l'inclinaison */
	double VectNod[4];

	inclinaison=acos(AxeW[3])*180/pi;
	/* Vecteur nodal */
	prodvect(AxeK,AxeW,VectNod);

	/* Dans le cas d'une inclinaison faible, on definit cette derniere
	   comme nulle et on affecte le vecteur nodal avec la valeur
	   de l'axe I.La longitude est alors nulle */
	if((inclinaison<1e-3)||(180-inclinaison<1e-3))
	{
		longitude =0;
		for (int gt=1; gt<4;gt++)
		VectNod[gt]=AxeI[gt];
	}
	else
	{
	/* La longitude est calculee fonction de l'inclinaison.
	   Cette derniere etant calculee grace a un arccos
	   on verifie donc que l'angle determine est le bon auquel
	   cas on le reoriente */
	longitude = acos(VectNod[1]/sin(inclinaison*pi/180));
	if (VectNod[2]<0) {(longitude = 2*pi-longitude);
	}
	}

	/* vecteur excentricite */
	double CV2[4],CV3[4],CV4[4],CV5[4];
	prodvect(RayonVecteurDepart,vitesse1,CV2);
	prodvect(vitesse1,CV2,CV3);
	multiplication_scalaire(1/Mu,CV3,CV4);
	unitaire(RayonVecteurDepart,CV5);
	multiplication_scalaire(-1,CV5,CV5);
	somme(CV4,CV5,VectExc);

	/* argument nodal au perigee */
	/* On verifie que l'angle determine est bien oriente sinon on
	   rectifie l'orientation */
	unitaire(VectNod,VectNod);
	e4=prodscal(VectNod,VectExc)/norme(VectExc);
	argument = acos(e4);
	if (VectExc[3]<0)
		(argument = 2*pi-argument);


	/* anomalie moyenne d'une date */
	M=phi1-excentricite*sin(phi1);


       /* Vitesse infini de depart et d'arrivee */
       Vinfini1=sqrt(2*(0.5*Nvitesse1*Nvitesse1-Mu/R1+Mu/R2));
       //Vinfini2=sqrt(2*(0.5*Nvitesse2*Nvitesse2-Mu/R2));

}



