/***************************************************************************
****************************************************************************
	FICHIER CONTENANT TOUTES LES OPERATIONS SUR LES VECTEURS
****************************************************************************
***************************************************************************/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>


double vect1[4], vect2[4], result[4];



// PRODUIT VECTORIEL DE DEUX VECTEURS

void prodvect ( double vect1[4], double vect2[4], double result[4])
{
	result[1]=vect1[2]*vect2[3]-vect1[3]*vect2[2];
	result[2]=vect1[3]*vect2[1]-vect1[1]*vect2[3];
	result[3]=vect1[1]*vect2[2]-vect1[2]*vect2[1];

	return;
}



// PRODUIT SCALAIRE DE DEUX VECTEURS

double prodscal (double vect1[4], double vect2[4])
{
	int i;
	double prod=0;

	for (i=1;i<4;i++)
	prod=prod + vect1[i]*vect2[i];

	return prod;

}


// MULTIPLICATION D'UN VECTEUR PAR UN SCALAIRE

void multiplication_scalaire (double lambda, double vect1[4], double result[4])
{
	for (int i=1; i<4; i++)
	result[i]=lambda*vect1[i];

	return;
}


// SOMME DE DEUX VECTEURS

void somme(double vect1[4], double vect2[4], double result[4])
{
	for(int i=1;i<4;i++)
	result[i]=vect1[i]+vect2[i];
	return;
}


// NORME D'UN VECTEUR

double norme(double vect1[4])
{
	double norma=0;

	for (int i=1; i<4;i++)
	norma=norma+vect1[i]*vect1[i];

	return sqrt(norma);
}



// ANGLE ENTRE DEUX VECTEURS

double angle_vecteur(double vect1[4], double vect2[4])
{
	double s;
	if ( norme(vect1)==0 || norme(vect2)==0 )
	printf("erreur: la norme d'un des vecteurs est nulle!\n");
	else s=acos(prodscal(vect1,vect2)/(norme(vect1)*norme(vect2)));

	return s;

}



// VECTEUR UNITAIRE

void unitaire (double vect1[4], double result[4])
{
	multiplication_scalaire(1/norme(vect1),vect1,result);
	return;
}

/* LES FONCTIONS ARCSINUS ARCCOSINUS ET ARCTANGENTE HYPERBOLIQUE N'ETANT
PAS DEFINIES DANS LE LANGUAGE C ELLES LE SONT PAR LA SUITE */

/*************************************************************************
			DEFINITION DE ASINH
*************************************************************************/

double asinh (double x)
{
	return log(x+ sqrt(x*x+1));
}

/*************************************************************************
			DEFINTION DE ACOSH
*************************************************************************/

double acosh (double x)
{
	if (x<0)
	{
		printf("Argument du acosh nul!!!\n");
		return 0;
	}
	else return log(x+sqrt(x*x-1));

}

/************************************************************************
			DEFINTION DE ATANH
************************************************************************/

double atanh (double x)
{
	return 0.5*log((1+x)/(1-x));
}


