/****************************************************************************
*****************************************************************************
			 PROBLEME DE LAMBERT
	FONCTIONS UTILES AU PROGRAME DE RESOLUTION DU PROBLEME DE LAMBERT
*****************************************************************************
****************************************************************************/



#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>

#define pi 3.141592654

//DECLARATION DES FONCTIONS EXTERNES UTILES A CE FICHIER:

extern double asinh (double);

//DECLARATION DES VARIABLES EXTERNES UTILES A CE FICHIERS:

extern double RayonVecteurDepart[];
extern double RayonVecteurArrivee[];





/**************************************************************************
			POUR UNE ELLIPSE A ZERO TOUR
**************************************************************************/

double  TempsEllipse0 (double  alpha, double  lambda)
{
	double  numerateur, denominateur, beta;

	beta= 2*asin(lambda*sin(alpha/2));
	numerateur= alpha-beta-sin(alpha)+sin(beta);
	denominateur=exp(3*log(sin(alpha/2)));
	return numerateur/denominateur;
}


/**************************************************************************
			POUR UNE ELLIPSE A N TOURS
**************************************************************************/

double TempsEllipseN (double alpha, double lambda, int Ntour)
{
	double numerateur, denominateur, beta;
	beta= 2*asin(lambda*sin(alpha/2));
	numerateur=alpha-beta-sin(alpha)+sin(beta)+Ntour*2*pi;
	denominateur=exp(3*log(sin(alpha/2)));
	return numerateur/denominateur;
}


/**************************************************************************
			POUR UNE HYPERBOLE
**************************************************************************/

double TempsHyperbole (double alpha, double lambda)
{
	double beta, numerateur, denominateur;
	double asinh (double);

	beta=2*asinh(lambda*sinh(alpha/2));
	numerateur=-alpha+beta+sinh(alpha)-sinh(beta);
	denominateur=exp(3*log(sinh(alpha/2)));
	return numerateur/denominateur;

}


/**************************************************************************
***************************************************************************
   consernant les coordonnes des plantes: l'utilisateur peut au choix:

   * saisir lui-mme leurs coordones

   * choisir le nom des plantes dans une liste; dans ce cas, nous utlisisons
     un programme en pascal, ephemeride.exe, pour calculer les positions
     des plantes.
     ATTENTION: pour le moment, les coordonnes ne sont calcules que pour la
		date du 01/01/2003 !!!
****************************************************************************
***************************************************************************/




/***************************************************************************
			SAISIE DES COORDONNEES DES POINTS
***************************************************************************/

void saisie_coord()
{
	printf("Vous allez maintenant saisir vos points de dpart et d'arrive.\n");
	printf("Point de dpart (en km):\n");

	printf("X1:");
	scanf("%le",&RayonVecteurDepart[1]);
	printf("X2:");
	scanf("%le",&RayonVecteurDepart[2]);
	printf("X3:");
	scanf("%le",&RayonVecteurDepart[3]);

	printf("\nPoint d'arrive (en km):\n");
	printf("X1:");
	scanf("%le",&RayonVecteurArrivee[1]);
	printf("X2:");
	scanf("%le",&RayonVecteurArrivee[2]);
	printf("X3:");
	scanf("%le",&RayonVecteurArrivee[3]);

}


/***************************************************************************
			CALCUL DES POSITIONS DES PLANETES
***************************************************************************/

void ephemeride()
{
	int p1, p2;
	p1=0;
	p2=0;

	while ((p1!=1)&&(p1!=2)&&(p1!=3)&&(p1!=4)&&(p1!=5)&&(p1!=6)&&(p1!=7)&&(p1!=8))
	{
	printf("\n");
	printf("Choisissez la plante de dpart parmi les plantes suivantes:\n");
	printf("1: Mercure\n2: Venus\n3: Terre\n4: Mars\n5: Jupiter\n6: Saturne\n7: Uranus\n8: Neptune\n\n");
	scanf("%d",&p1);
	}

	while ((p2!=1)&&(p2!=2)&&(p2!=3)&&(p2!=4)&&(p2!=5)&&(p2!=6)&&(p2!=7)&&(p2!=8))
	{
	printf("\n");
	printf("Choisissez la plante d'arrive parmi les plantes suivantes:\n");
	printf("1: Mercure\n2: Venus\n3: Terre\n4: Mars\n5: Jupiter\n6: Saturne\n7: Uranus\n8: Neptune\n\n");
	scanf("%d",&p2);
	}

	printf("\nREMARQUE: On calcule la position des plantes le 01/01/2003  00h00m00s.\n\n");


	switch (p1)
	{
	case 1:  {
		RayonVecteurDepart[1]=34060000;
		RayonVecteurDepart[2]=3288400;
		RayonVecteurDepart[3]=-444000;
		}
	break;

	case 2:  {
		RayonVecteurDepart[1]=-78741785.36;
		RayonVecteurDepart[2]=72944657.5;
		RayonVecteurDepart[3]=5544513.894;
		}
	break;

	case 3:  {
		RayonVecteurDepart[1]=-25922000;
		RayonVecteurDepart[2]=144800000;
		RayonVecteurDepart[3]=0;
		}
	break;

	case 4:  {
		RayonVecteurDepart[1]=-224865000;
		RayonVecteurDepart[2]=-88826000;
		RayonVecteurDepart[3]=3669000;
		}
	break;

	case 5:  {
		RayonVecteurDepart[1]=-515184000;
		RayonVecteurDepart[2]=602999000;
		RayonVecteurDepart[3]=9025000;
		}
	break;

	case 6:  {
		RayonVecteurDepart[1]=91426000;
		RayonVecteurDepart[2]=1347137000;
		RayonVecteurDepart[3]=-27166000;
		}
	break;

	case 7:  {
		RayonVecteurDepart[1]=2548498000;
		RayonVecteurDepart[2]=-1576820000;
		RayonVecteurDepart[3]=-38935000;
		}
	break;

	case 8:  {
		RayonVecteurDepart[1]=2924144000;
		RayonVecteurDepart[2]=-3429737000;
		RayonVecteurDepart[3]=3321000;
		}
	break;
	}


	switch (p2)
	{
	case 1:  {
		RayonVecteurArrivee[1]=34060000;
		RayonVecteurArrivee[2]=3288400;
		RayonVecteurArrivee[3]=-444000;
		}
	break;

	case 2:  {
		RayonVecteurArrivee[1]=-78741785.36;
		RayonVecteurArrivee[2]=72944657.5;
		RayonVecteurArrivee[3]=5544513.894;
		}
	break;

	case 3:  {
		RayonVecteurArrivee[1]=-25922000;
		RayonVecteurArrivee[2]=144800000;
		RayonVecteurArrivee[3]=0;
		}
	break;

	case 4:  {
		RayonVecteurArrivee[1]=-224865000;
		RayonVecteurArrivee[2]=-88826000;
		RayonVecteurArrivee[3]=3669000;
		}
	break;

	case 5:  {
		RayonVecteurArrivee[1]=-515184000;
		RayonVecteurArrivee[2]=602999000;
		RayonVecteurArrivee[3]=9025000;
		}
	break;

	case 6:  {
		RayonVecteurArrivee[1]=91426000;
		RayonVecteurArrivee[2]=1347137000;
		RayonVecteurArrivee[3]=-27166000;
		}
	break;

	case 7:  {
		RayonVecteurArrivee[1]=2548498000;
		RayonVecteurArrivee[2]=-1576820000;
		RayonVecteurArrivee[3]=-38935000;
		}
	break;

	case 8:  {
		RayonVecteurArrivee[1]=2924144000;
		RayonVecteurArrivee[2]=-3429737000;
		RayonVecteurArrivee[3]=3321000;
		}
	break;
	}
}


/**************************************************************************
	    UNE PLANETE AU DEPART, DES COORDONNEES D'ARRIVEE
**************************************************************************/

void planete_coord()
{
	int p1;
	p1=0;

	while ((p1!=1)&&(p1!=2)&&(p1!=3)&&(p1!=4)&&(p1!=5)&&(p1!=6)&&(p1!=7)&&(p1!=8))
	{
	printf("\n");
	printf("Choisissez la plante de dpart parmi les plantes suivantes:\n");
	printf("1: Mercure\n2: Venus\n3: Terre\n4: Mars\n5: Jupiter\n6: Saturne\n7: Uranus\n8: Neptune\n\n");
	scanf("%d",&p1);
	}

	printf("\nREMARQUE: On calcule la position des plantes le 01/01/2003  00h00m00s.\n\n");


	switch (p1)
	{
	case 1:  {
		RayonVecteurDepart[1]=34060000;
		RayonVecteurDepart[2]=3288400;
		RayonVecteurDepart[3]=-444000;
		}
	break;

	case 2:  {
		RayonVecteurDepart[1]=-78741785.36;
		RayonVecteurDepart[2]=72944657.5;
		RayonVecteurDepart[3]=5544513.894;
		}
	break;

	case 3:  {
		RayonVecteurDepart[1]=-25922000;
		RayonVecteurDepart[2]=144800000;
		RayonVecteurDepart[3]=0;
		}
	break;

	case 4:  {
		RayonVecteurDepart[1]=-224865000;
		RayonVecteurDepart[2]=-88826000;
		RayonVecteurDepart[3]=3669000;
		}
	break;

	case 5:  {
		RayonVecteurDepart[1]=-515184000;
		RayonVecteurDepart[2]=602999000;
		RayonVecteurDepart[3]=9025000;
		}
	break;

	case 6:  {
		RayonVecteurDepart[1]=91426000;
		RayonVecteurDepart[2]=1347137000;
		RayonVecteurDepart[3]=-27166000;
		}
	break;

	case 7:  {
		RayonVecteurDepart[1]=2548498000;
		RayonVecteurDepart[2]=-1576820000;
		RayonVecteurDepart[3]=-38935000;
		}
	break;

	case 8:  {
		RayonVecteurDepart[1]=2924144000;
		RayonVecteurDepart[2]=-3429737000;
		RayonVecteurDepart[3]=3321000;
		}
	break;
	}

	printf("\n");
	printf("Entrer les coordonnes du point d'arrive (en km):\n");
	printf("X1: ");
	scanf("%lf",&RayonVecteurArrivee[1]);
	printf("X2: ");
	scanf("%lf",&RayonVecteurArrivee[2]);
	printf("X3: ");
	scanf("%lf",&RayonVecteurArrivee[3]);

}




/**************************************************************************
	COORDONNEES DE DEPART, PLANETE  L'ARRIVEE
**************************************************************************/

void coord_planete()
{
	printf("\n");
	printf("Entrer les coordonnes du point de dpart (en km):\n");
	printf("X1: ");
	scanf("%lf",&RayonVecteurDepart[1]);
	printf("X2: ");
	scanf("%lf",&RayonVecteurDepart[2]);
	printf("X3: ");
	scanf("%lf",&RayonVecteurDepart[3]);

	int p2;

	p2=0;

	while ((p2!=1)&&(p2!=2)&&(p2!=3)&&(p2!=4)&&(p2!=5)&&(p2!=6)&&(p2!=7)&&(p2!=8))
	{
	printf("\n");
	printf("Choisissez la plante d'arrive parmi les plantes suivantes:\n");
	printf("1: Mercure\n2: Venus\n3: Terre\n4: Mars\n5: Jupiter\n6: Saturne\n7: Uranus\n8: Neptune\n\n");
	scanf("%d",&p2);
	}

	printf("\nREMARQUE: On calcule la position des plantes le 01/01/2003  00h00m00s.\n\n");

	switch (p2)
	{
	case 1:  {
		RayonVecteurArrivee[1]=34060000;
		RayonVecteurArrivee[2]=3288400;
		RayonVecteurArrivee[3]=-444000;
		}
	break;

	case 2:  {
		RayonVecteurArrivee[1]=-78741785.36;
		RayonVecteurArrivee[2]=72944657.5;
		RayonVecteurArrivee[3]=5544513.894;
		}
	break;

	case 3:  {
		RayonVecteurArrivee[1]=-25922000;
		RayonVecteurArrivee[2]=144800000;
		RayonVecteurArrivee[3]=0;
		}
	break;

	case 4:  {
		RayonVecteurArrivee[1]=-224865000;
		RayonVecteurArrivee[2]=-88826000;
		RayonVecteurArrivee[3]=3669000;
		}
	break;

	case 5:  {
		RayonVecteurArrivee[1]=-515184000;
		RayonVecteurArrivee[2]=602999000;
		RayonVecteurArrivee[3]=9025000;
		}
	break;

	case 6:  {
		RayonVecteurArrivee[1]=91426000;
		RayonVecteurArrivee[2]=1347137000;
		RayonVecteurArrivee[3]=-27166000;
		}
	break;

	case 7:  {
		RayonVecteurArrivee[1]=2548498000;
		RayonVecteurArrivee[2]=-1576820000;
		RayonVecteurArrivee[3]=-38935000;
		}
	break;

	case 8:  {
		RayonVecteurArrivee[1]=2924144000;
		RayonVecteurArrivee[2]=-3429737000;
		RayonVecteurArrivee[3]=3321000;
		}
	break;
	}
}