/**************************************************************************
***************************************************************************
			PROBLEME DE LAMBERT
		PROGRAMME CONTENANT LES FONCTIONS DE SAISIE
***************************************************************************
**************************************************************************/



#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>

#define pi 3.141592654



//DECLARATION DES FONCTIONS EXTERNES UTILES A CE FICHIER:

extern double norme (double []);
extern double angle_vecteur( double [], double []);
extern double solution_equation_elliptique_0_tour ();
extern double Solution_du_probleme(double);
extern double classification_des_cas();
extern double premiere_solution_NTour();
extern double deuxieme_solution_NTour();

extern void ephemeride();
extern void saisie_coord();
extern void planete_coord();
extern void coord_planete();
extern void solution_elliptique();
extern void prodvect (double [],double [], double []);
extern void multiplication_scalaire (double, double [], double[]);
extern void traitement_cas_vol(int );
extern void dernier_parametre ();
extern void afficher_elliptique();
extern void repeter();


//DECLARATION DES VARIABLES EXTERNES UTILES A CE FICHIER:

extern double DureeMini;
extern double a;
extern double excentricite;
extern double ra, rp;
extern double argument;
extern double inclinaison;
extern double longitude;
extern double M;
extern double vitesse1[];
extern double vitesse2[];
extern double V[];
extern double phi1,phi2;
extern double teta1,teta2;
extern double Nvitesse1,Nvitesse2;
extern double gamma1,gamma2;
extern double Vinfini1,Vinfini2;

extern int cas_de_vol;


//DECLARATION DES VARIABLES LOCALES A CE FICHIER:

double RayonVecteurDepart[4],RayonVecteurArrivee[4];
double W12[4], W[4], AxeI[4], AxeJ[4], AxeK[4];
double R1, R2, S, D, Angle, Delta, Delta_T, Mu, Lambda, choix;

int NTour, Helios, SensParcours,RetourDebut,Choix_Vol_Long_Court;
int reponse, planete1,planete2;
int compteur=0;
int saisie;

char nom_mission[20];
char nom,nom1, azerty, encore;



/***************************************************************************
			FONCTION DE SAISIE
			ET QUELQUES CALCULS
***************************************************************************/



void saisir ()
{
	planete1=0;
	planete2=0;

	printf ("\n");
	printf("*******************************************************************************\n");
	printf("**                      PROJET: RESOLUTION DU PROBLEME DE LAMBERT            **\n");
	printf("**	 		  EMILIE CASTELLANI ET ISABELLE DAUVIN               **\n");
	printf("**	                    PROMOTION 2002/2003 DU DESS TAE                  **\n");
	printf("*******************************************************************************\n");
	printf("\n");




	//CHOIX DU NOM DE LA MISSION EVENTUELLEMENT
	nom='o';

	while ((nom=='o')||(nom=='O'))
	{

	printf("Voulez-vous donner un nom  la mission? (o/n): ");
	scanf("%c",&nom);

	if (compteur!=0)    //astuce pour permettre de demander le nom
	{	scanf("%c",&nom1);       //de la misison quand on relance le programme
		azerty=nom1;
		compteur=1;
		if ((nom1=='O')||(nom1=='o'))
		{	nom1='n';
			printf("\n\nEntrer le nom de la mission (20 caractres au maximum):\n");
			getchar();
			gets(nom_mission);
		}
	}


	azerty=nom;
	compteur=1;

	if ((nom=='O')||(nom=='o'))
	{
		nom='n';
		printf("\n\nEntrer le nom de la mission (20 caractres au maximum):\n");
		getchar();

		gets(nom_mission);
	}

	} //fin du while



	/* CHOIX DU VOL HELIOCENTRIQUE OU GEOCENTRIQUE*/
	/* Seule varie la valeur de Mu */


	Helios=0;

	printf("\n\nVoulez-vous un vol gocentrique (taper 0) ou un vol hliocentrique (taper 1)? ");
	scanf("%d",&Helios);

	while ( (Helios!=1) && (Helios!=0))
	{
		printf("Vous avez fait un mauvais choix! Recommencez.\n\n");
		printf("Voulez-vous un vol gocentrique (taper 0) ou un vol hliocentrique (taper 1)? ");
		scanf("%d",&Helios);
	}

	if (Helios==1) Mu=13.271244e10;

	if (Helios==0) Mu=39.860064e4;



	/* SAISIE DES POINTS DE DEPART ET D'ARRIVEE  */

	RetourDebut=0;
	while (RetourDebut==0)
	{
		reponse=0;

		printf("\n");

/*	do
	{
	printf("Vous pouvez:\n\n");
	printf("choix 1: entrer les coordonnes des points de dpart et d'arrive\n"),
	printf("choix 2: entrer le nom des plantes de dpart et d'arrive\n");
	printf("choix 3: choisir une plante de dpart et entrer les coordonnes d'arrive.\n");
	printf("choix 4: entrer les coordonnes de dpart et choisir une plante d'arrive.\n\n");

	printf("ATTENTION: dans les choix 2,3 et 4, Pluton n'est pas une plante accessible!!!\n\n");
	printf("Quel est votre choix (1, 2, 3, 4)? ");
	scanf ("%d",&reponse);
	printf("\n");
	}
	while ((reponse!=1)&&(reponse!=2)&&(reponse!=3)&&(reponse!=4));

	if (reponse==1) saisie_coord();

	if (reponse==2) {ephemeride();planete1=1;planete2=1;}

	if (reponse==3) {planete_coord();planete1=1;}

	if (reponse==4) {coord_planete();planete2=1;}
*/


     saisie_coord();

     //pour tester, retirer // des 6 lignes de commandes ci-dessous
     //RayonVecteurDepart[1]=89977.81;
     //RayonVecteurDepart[2]=54044.81;
     //RayonVecteurDepart[3]=-52998.54;
     //RayonVecteurArrivee[1]=65206.59;
     //RayonVecteurArrivee[2]=35375.58;
     //RayonVecteurArrivee[3]=-37206.90;




	/* VERIFICATION DE LA NON COLINEARITE DES VECTEURS DE DEPART ET D'ARRIVEE */

	prodvect(RayonVecteurDepart, RayonVecteurArrivee, W12);
	if (W12[3]>0) SensParcours=1;
		      else SensParcours=0;

	if (norme(W12)>0) RetourDebut=1;

	if (norme(W12)==0)
	{
	printf("Les points de dpart, d'arrive et le corps central sont aligns.\n");
	printf("C'est un cas singulier que nous ne traitons pas.\n\n\n");
	RetourDebut=0;
	}

	}//fin du while retour debut



	/* SAISIE DE LA DUREE DU PARCOURS */

	printf("\nEntrer la dure souhaite du parcours EN JOURS DECIMAUX: ");
	scanf("%lf", &Delta_T);

	while(Delta_T<0)
	{
	printf ("Vous avez rentr un temps ngatif!!! Veuillez recommencer.\n\n");
	printf("Entrer la dure souhaite du parcours EN JOURS DECIMAUX: ");
	scanf("%lf", &Delta_T);
	}


	/* CHOIX DU NOMBRE DE TOURS */
	int tour=1;

	while(tour==1)
	{
	printf("\nCombien de tours voulez-vous faire (4 au maximum)? ");

	scanf("%d",&NTour);

	if ((NTour>=0) && (NTour<5)) tour=0;
	}



	/* DEFINITION DES AXES I , J ET K */

	AxeI[1]=1;
	AxeI[2]=0;
	AxeI[3]=0;

	AxeJ[1]=0;
	AxeJ[2]=1;
	AxeJ[3]=0;

	AxeK[1]=0;
	AxeK[2]=0;
	AxeK[3]=1;




	/* CALCULS INTERMEDIAIRES  */


	/* Calcul de la norme du vecteur de depart et d'arrivee */
	R1=norme(RayonVecteurDepart);
	R2=norme(RayonVecteurArrivee);

	/* Angle entre les vecteurs de depart et d'arrivee */
	Angle=angle_vecteur(RayonVecteurDepart, RayonVecteurArrivee);
	D=sqrt(R1*R1+R2*R2-2*R1*R2*cos(Angle));
	S=(R1+R2+D)/2;

	/* CHOIX D'UN VOYAGE LONG OU COURS */
	printf("\n\n");

	if (Helios==1)
	{
		if (SensParcours==1)
		{
		printf("Voulez-vous un vol court dans le sens des plantes (entrer 1) ou long dans le sens contraire (entrer 2)? ");
		scanf("%d",&Choix_Vol_Long_Court);

		while ((Choix_Vol_Long_Court!=1) && (Choix_Vol_Long_Court!=2))
		{
		printf("\nVous avez fait un mauvais choix. Recommencer.\n");
		printf("Voulez-vous un vol court dans le sens des plantes (entrer 1) ou long dans le sens contraire (entrer 2)? ");
		scanf("%d",&Choix_Vol_Long_Court);
		}
		}

		if (SensParcours==0)
		{
			printf("Voulez-vous un vol long dans le sens des plantes (entrer 3) ou court dans le sens contraire (entrer 4)? ");
			scanf("%d",&Choix_Vol_Long_Court);

			while ((Choix_Vol_Long_Court!=3) && (Choix_Vol_Long_Court!=4))
			{
			printf("\nVous avez fait un mauvais choix. Recommencer.\n");
			printf("Voulez-vous un vol long dans le sens des plantes (entrer 3) ou court dans le sens contraire (entrer 4)? ");
			scanf("%d",&Choix_Vol_Long_Court);
			}
		}
	}//fin du if helios==1


	if (Helios==0)
	{
		if (SensParcours==1)
		{
		printf("Voulez-vous un vol: court (inclinaison<90 entrer 1)\n");
		printf("                    ou long (inclinaison>=90 entrer 2)? ");
		scanf("%d",&Choix_Vol_Long_Court);

		while ((Choix_Vol_Long_Court!=1) && (Choix_Vol_Long_Court!=2))
		{
		printf("\nVous avez fait un mauvais choix. Recommencer.\n");
		printf("Voulez-vous un vol: court (inclinaison<90 entrer 1)\n");
		printf("                    ou long (inclinaison>=90 entrer 2)? ");
		scanf("%d",&Choix_Vol_Long_Court);
		}
		}

		if (SensParcours==0)
		{
		printf("Voulez-vous un vol: long (inclinaison<90 entrer 3) \n");
		printf("                    ou court (inclinaison>=90 entrer 4)? ");
		scanf("%d",&Choix_Vol_Long_Court);

		while ((Choix_Vol_Long_Court!=3) && (Choix_Vol_Long_Court!=4))
		{
		printf("\nVous avez fait un mauvais choix. Recommencer.\n");
		printf("Voulez-vous un vol: long (inclinaison<90 entrer 3)\n");
		printf("                    ou court (inclinaison>=90 entrer 4)? ");
		scanf("%d",&Choix_Vol_Long_Court);
		}

		}
	} //fin du if helios==0


	/* CALCUL DE DELTA */

	if ( (Choix_Vol_Long_Court==1) || (Choix_Vol_Long_Court==4) )
	{
		Delta=Angle;
		for (int k=0; k<4; k++)
		W[k]=W12[k];
		Lambda= (sqrt(R1*R2)*cos(Delta/2))/S;
	}

	if ( (Choix_Vol_Long_Court==2) || (Choix_Vol_Long_Court==3) )
	{
		Delta=2*pi-Angle;
		multiplication_scalaire(-1,W12,W);
		Lambda=sqrt(R1*R2)*cos(Delta/2)/S;
	}

	solution_elliptique();

}




void main()
{
	clrscr();
	void saisir();

	encore='o';
	saisie=1;
	repeter();
}